Index: orxonox/branches/levelloader/src/Makefile.am
===================================================================
--- orxonox/branches/levelloader/src/Makefile.am	(revision 3606)
+++ orxonox/branches/levelloader/src/Makefile.am	(revision 3746)
@@ -37,4 +37,5 @@
 		 simple_animation.cc \
 		 factory.cc \
+		 garbage_collector.cc \
 		 story_entities/story_entity.cc \
 		 story_entities/campaign.cc \
@@ -45,8 +46,9 @@
 		 world_entities/skysphere.cc \
 		 world_entities/terrain.cc \
-		 world_entities/primitive.cc \
 		 world_entities/weapon.cc \
 		 world_entities/projectile.cc \
 		 world_entities/character_attributes.cc \
+		 world_entities/test_gun.cc \
+		 world_entities/test_bullet.cc \
 		 ai/ai.cc \
 		 lib/coord/p_node.cc \
@@ -54,8 +56,10 @@
 		 lib/coord/helper_parent.cc \
 		 lib/data/data_tank.cc \
+		 lib/graphics/graphics_engine.cc \
 		 lib/graphics/light.cc \
 		 lib/graphics/font/fontset.cc \
 		 lib/graphics/importer/array.cc \
 		 lib/graphics/importer/objModel.cc \
+		 lib/graphics/importer/primitive_model.cc \
 		 lib/graphics/importer/model.cc \
 		 lib/graphics/importer/material.cc \
@@ -66,4 +70,5 @@
 		 lib/util/list.cc \
 		 lib/util/substring.cc \
+		 lib/util/resource_manager.cc \
 		 lib/math/vector.cc \
 		 lib/math/curve.cc \
@@ -73,4 +78,5 @@
 		 lib/xmlparser/tinyxmlparser.cc \
 		 glmenu/glmenu_imagescreen.cc 
+		 glmenu/glmenu_imagescreen.cc
 
 noinst_HEADERS = orxonox.h \
@@ -80,5 +86,4 @@
 		 camera.h \
 		 keynames.h \
-		 proto_class.h \
 		 command_node.h \
 		 message_structures.h \
@@ -86,4 +91,5 @@
 		 track_node.h \
 		 simple_animation.h \
+		 garbage_collector.h \
 		 story_entities/story_entity.h \
 		 story_entities/story_def.h \
@@ -97,12 +103,14 @@
 		 world_entities/power_up.h \
 		 world_entities/terrain.h \
-		 world_entities/primitive.h \
 		 world_entities/weapon.h \
 		 world_entities/projectile.h \
 		 world_entities/character_attributes.h \
+		 world_entities/test_gun.h \
+		 world_entities/test_bullet.h \
 		 ai/ai.h \
 		 network/synchronisable.h \
 		 defs/stdincl.h \
 		 defs/glincl.h \
+		 defs/comincl.h \
 		 defs/error.h \
 		 defs/debug.h \
@@ -110,4 +118,5 @@
 		 lib/coord/null_parent.h \
 		 lib/coord/helper_parent.h \
+		 lib/graphics/graphics_engine.h \
 		 lib/graphics/light.h \
 		 lib/graphics/font/fontset.h \
@@ -117,4 +126,5 @@
 		 lib/util/list.h \
 		 lib/util/list_template.h \
+		 lib/util/resource_manager.h \
 		 lib/util/ini_parser.h \
 		 lib/util/substring.h \
@@ -127,5 +137,9 @@
 
 ## orxonox.conf will be used from home-dir instead.
-EXTRA_DIST = orxonox.conf
+EXTRA_DIST = orxonox.conf \
+	     proto/proto_class.h \
+	     proto/proto_class.cc \
+	     proto/proto_singleton.h \
+	     proto/proto_singleton.cc
 
 if SUB_PROJECTS
Index: orxonox/branches/levelloader/src/camera.cc
===================================================================
--- orxonox/branches/levelloader/src/camera.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/camera.cc	(revision 3746)
@@ -17,31 +17,28 @@
 
 #include "camera.h"
+
 #include "world.h"
 #include "world_entity.h"
+#include "vector.h"
 
 using namespace std;
 
+////////////
+// CAMERA //
+////////////
+
 /**
    \brief creates a Camera
-   
-   This standard constructor sets all parameters to zero
 */
-Camera::Camera (World* world)
+Camera::Camera(void)
 {
-  this->world = world;
-  this->bound = NULL;
-  /* give it some physical live */
-  this->m = 10;
-  this->a = new Vector(0.0, 0.0, 0.0);
-  this->v = new Vector(0.0, 0.0, 0.0);
-  this->fs = new Vector(0.0, 0.0, 0.0);
-  this->cameraMode = NORMAL;
-  this->deltaTime = 3000.0;
-  this->cameraOffset = 1.0;
-  this->cameraOffsetZ = 10.0;
-  this->t = 0.0;
+  this->setClassName("Camera");
+  this->target = new CameraTarget();
 
+  this->setFovy(90);
+  this->setAspectRatio(1.2f);
+  this->setClipRegion(.1, 2000);
 
-  this->setDrawable (false);
+  this->setViewMode(VIEW_NORMAL);
 }
 
@@ -49,142 +46,105 @@
    \brief default destructor
 */
-Camera::~Camera ()
+Camera::~Camera(void)
 {
-  this->bound = NULL;
-  this->world = NULL;
-
 }
 
 /**
-   \brief time based actualisation of camera parameters
-   \param deltaT: The amount of time that has passed in milliseconds
-   
-   This is called by the World in every time_slice, use it to do fancy time dependant effects (such 
-   as smooth camera movement or swaying).
+   \brief focuses the Camera onto a Target
+   \param target the new PNode the Camera should look at.
 */
-void Camera::tick (Uint32 deltaT)
+void Camera::lookAt(PNode* target)
 {
-  if( this->t <= deltaTime)
-    {this->t += deltaT;}
-  //printf("time is: t=%f\n", t );
-  updateDesiredPlace();
-  //jump(NULL);
+  this->target->setParent(target);
 }
 
 /**
-   \brief this calculates the location where the track wants the camera to be
-   
-   This refreshes the placement the camera should have according to the 
-   bound entity's position on the track.
+   \returns The PNode of the Target (from there you can get position and so on
 */
-void Camera::updateDesiredPlace ()
+PNode* Camera::getTarget(void)
 {
-  switch(cameraMode)
-    {
-      
-    case ELLIPTICAL:
-      {
-	/*
-	//r = actual_place.r 
-	Orxonox *orx = Orxonox::getInstance();
-	Location lookat;  
-	Placement plFocus;
-	if( bound != NULL)
-	  {
-	    bound->getLookat (&lookat);
-	    orx->getWorld()->calcCameraPos (&lookat, &plFocus);
-	    Quaternion *fr;
-	    if(t < 20.0)
-	      {
-		Vector *start = new Vector(0.0, 1.0, 0.0);
-		r = *(new Vector(0.0, 5.0, 0.0));
-
-		Vector up(0.0, 0.0, 1.0);
-		
-		Vector op(1.0, 0.0, 0.0);
-		float angle = angleDeg(op, *start);
-		printf("angle is: %f\n", angle);
-
-		//if in one plane
-		from = new Quaternion(angle, up);
-
-		//from = new Quaternion(*start, *up);
-		//&from = &plFocus.w;
-		//fr = &plFocus.w; real quaternion use
-		
+  return (PNode*)this->target;
+}
 
 
-		Vector vDirection(1.0, 0.0, 0.0);
-		//vDirection = plFocus.w.apply(vDirection);
-		to = new Quaternion(vDirection, *start);
-		res = new Quaternion();
-	      }
-	    //printf("vector r = %f, %f, %f\n",r.x, r.y, r.z );
-	    rAbs = r.len();
-	    if(t < 30)
-	      {
-		ka = rAbs / deltaTime*deltaTime;
-	      }
+/**
+   \brief sets a new AspectRatio
+   \param aspectRatio the new aspect ratio to set (width / height)
+*/
+void Camera::setAspectRatio(float aspectRatio)
+{
+  this->aspectRatio = aspectRatio;
+}
 
-	    res->quatSlerp(to, from, t/deltaTime, res);
+/**
+   \brief sets the Field of View to fofy
+   \param fovy new field of view factor (in degrees)
+*/
+void Camera::setFovy(float fovy)
+{
+  this->fovy = fovy;
+}
 
-	    Vector ursp(0.0, 0.0, 0.0);
-	    desiredPlace.r =  ursp - res->apply(r); 
+/**
+  \brief Sets a new clipping region
+  \param nearClip The near clip plane
+  \param farClip The far clip plane
+*/
+void Camera::setClipRegion(float nearClip, float farClip)
+{
+  this->nearClip = nearClip;
+  this->farClip = farClip;
+}
 
-	    printf("desired place is: %f, %f, %f\n", desiredPlace.r.x, desiredPlace.r.y, desiredPlace.r.z);
-	    //plLastBPlace = *bound->get_placement();
-	    
-	  } 
-      */
-      }
+void Camera::setViewMode(ViewMode mode)
+{
+  switch (mode)
+    {
+    default:
+    case VIEW_NORMAL:
+      this->toFovy = 60.0;
+      this->toRelCoor = Vector(-10, 5, 0);
       break;
-    case SMOTH_FOLLOW:
-      {
-	/*
-	Placement *plBound = bound->getPlacement();
-	Location lcBound;
-	if(bound != null)
-	  {
-	    bound->getLookat(&lcBound);
-	    Vector vDirection(0.0, 0.0, 1.0);
-	    vDirection = plBound->w.apply(vDirection);
-	    desiredPlace.r = (vDirection * ((lcBound.dist-10.0))) + Vector(0,0,5.0);
-	  }
-	*/
-	break;
-      }
-      /* this is a camera mode that tries just to follow the entity. */
-    case STICKY:
-      {
-	/*
-	if(bound != null)
-	  {
-	    Placement *plBound = bound->getPlacement();
-	    Vector vDirection(0.0, 0.0, 1.0);
-	    Vector eclipticOffset(0.0, 0.0, 5.0);
-	    vDirection = plBound->w.apply(vDirection);
-	    desiredPlace.r = plBound->r - vDirection*10 + eclipticOffset;
-	  }
-	*/
-	break;
-      }
-      /* the camera is handled like an entity and rolls on the track */
-    case NORMAL:
-      if( bound != NULL && world != NULL )
-	{
-	  //FIXME: camera should be made via relative coordinates
-	  Vector* cameraOffset = new Vector (-10, 5, 0);
-	  this->setRelCoor (cameraOffset);
-	} 
-      else
-	{
-	  /*
-	  desiredPlace.r = Vector (0,0,0);
-	  desiredPlace.w = Quaternion (); 
-	  */
-	}
+    case VIEW_BEHIND:
+      this->toFovy = 120.0;
+      this->toRelCoor = Vector(-7, 0, 0);
       break;
+    case VIEW_FRONT:
+      this->toFovy = 95.0;
+      this->toRelCoor = Vector(12, 5, 0);
+      break;
+    case VIEW_LEFT: 
+      this->toFovy = 90;
+      this->toRelCoor = Vector(0, 2, -10);
+      break;
+    case VIEW_RIGHT:
+      this->toFovy = 90;
+      this->toRelCoor = Vector(0, 2, 10);
+      break;
+    case VIEW_TOP:
+      this->toFovy= 120;
+      this->toRelCoor = Vector(0, 4, 0);
     }
 }
+
+
+/**
+   \brief Updates the position of the camera.
+   \param dt The time that elapsed.
+*/
+void Camera::tick(float dt)
+{
+  dt /= 500;
+  float tmpFovy = (this->toFovy - this->fovy) * dt;
+  if (tmpFovy > .001)
+    this->fovy += (this->toFovy - this->fovy) * dt;
+  Vector tmpPos = (this->toRelCoor - *this->getRelCoor()) * dt;
+  if (tmpPos.len() >= .001)
+    {
+      tmpPos = tmpPos + *this->getRelCoor();
+      this->setRelCoor(&tmpPos);
+    }
+}
+
 
 /**
@@ -196,85 +156,44 @@
 void Camera::apply ()
 {
+  // switching to Projection Matrix
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
-  // view
-  // TO DO: implement options for frustum generation
-  //glFrustum(-1.0, 1.0, -1.0, 1.0, 1.5, 250.0);
-  gluPerspective(60, 1.2f, 0.1, 2000);
-  
-  //Vector up(0,0,1);
-  //Vector dir(1,0,0);
-  //Quaternion q(dir,up);
-  //float matrix[4][4];
-  //q.conjugate().matrix (matrix);
-  //glMultMatrixf ((float*)matrix);
-  //glTranslatef (10,0,-5);
-  //
-  //dir = Vector(-1,-1,0);
-  //q = Quaternion( dir, up);
-  //glMatrixMode (GL_MODELVIEW);
-  //glLoadIdentity ();
-  //q.matrix (matrix);
-  //glMultMatrixf ((float*)matrix);
-  //glTranslatef (2,2,0);
-  //
-  //glBegin(GL_TRIANGLES);
-  //glColor3f(1,0,0);
-  //glVertex3f(0,0,0.5);
-  //glColor3f(0,1,0);
-  //glVertex3f(-0.5,0,-1);
-  //glColor3f(0,0,1);
-  //glVertex3f(0.5,0,-1);
-  //glEnd();	
 
-  // ===== first camera control calculation option
-  // rotation
-  float matrix[4][4];
-  //this->absDirection.conjugate().matrix (matrix);
-  /* orientation and */
-  //glMultMatrixf ((float*)matrix);
+  // setting up the perspective
+  gluPerspective(this->fovy,
+		 this->aspectRatio,
+		 this->nearClip,
+		 this->farClip);
 
-  /*  translation */
-  //glTranslatef (this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z );
+  // speed-up feature
+  Vector cameraPosition = this->getAbsCoor();
+  Vector targetPosition = this->target->getAbsCoor();
+  Vector up = Vector(0, 1, 0);
+  up = this->getAbsDir().apply(up);
 
+  // Setting the Camera Eye, lookAt and up Vectors
+  gluLookAt(cameraPosition.x, cameraPosition.y, cameraPosition.z,
+	    targetPosition.x, targetPosition.y, targetPosition.z,
+	    up.x, up.y, up.z);
 
-  // ===== second camera control calculation option
-  
-  gluLookAt(this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z, 
-	    this->parent->getAbsCoor ().x, this->parent->getAbsCoor ().y, this->parent->getAbsCoor ().z,
-	    0.0, 1.0, 0.0);
-  
-
+  // switching back to Modeling Matrix
   glMatrixMode (GL_MODELVIEW);
-  glLoadIdentity ();
 }
 
 
 
-/**
-  \brief bind the camera to an entity
-  \param entity: The enitity to bind the camera to
-	
-  This sets the focus of the camera to the given entity. This means that it will use the given WorldEntity's
-  Location and get_lookat() to determine the viewpoint the camera will render from.
-  Note that you cannot bind a camera to a free entity.
-*/
-void Camera::bind (WorldEntity* entity)
+///////////////////
+// CAMERA-TARGET //
+///////////////////
+
+
+CameraTarget::CameraTarget()
 {
-  if( entity != NULL)
-    {
-      if( entity->isFree()) printf("Cannot bind camera to free entity");
-      else 
-	{
-	  this->bound = entity;
-	}
-    } 
+  this->setClassName("CameraTarget");
+  this->setMode(PNODE_MOVEMENT);
 }
 
+CameraTarget::~CameraTarget()
+{
 
-void Camera::setWorld(World* world)
-{
-  this->world = world;
 }
-
-
Index: orxonox/branches/levelloader/src/camera.h
===================================================================
--- orxonox/branches/levelloader/src/camera.h	(revision 3606)
+++ orxonox/branches/levelloader/src/camera.h	(revision 3746)
@@ -7,60 +7,57 @@
 #define _CAMERA_H
 
-#include "world_entity.h"
+#include "p_node.h"
+#include "vector.h"
 
 class World;
+class CameraTarget;
+
+enum ViewMode{VIEW_NORMAL, VIEW_BEHIND, VIEW_FRONT, VIEW_LEFT, VIEW_RIGHT, VIEW_TOP};
 
 //! Camera
 /**
-   This class controls the viewpoint from which the World is rendered. To use the 
-   Camera it has to be bound to a WorldEntity which serves as the reference focus 
-   point. The Camera itself calls the WorldEntity::get_lookat() and 
-   World::calc_camera_pos() functions to calculate the position it currently should
-   be in.
+   This class controls the viewpoint from which the World is rendered.
 */
+class Camera : public PNode 
+{
+ private:
+  CameraTarget* target;            //!< The Target of the Camera (where this Camera Looks at)
 
-enum CAMERA_MODE {NORMAL, SMOTH_FOLLOW, STICKY, ELLIPTICAL};
+  float fovy;                      //!< The field of view Angle (in degrees).
+  float aspectRatio;               //!< The aspect ratio (width / height).
+  float nearClip;                  //!< The near clipping plane.
+  float farClip;                   //!< The far clipping plane.
 
-class Camera : public WorldEntity {
- private:
-  WorldEntity* bound;		//!< the WorldEntity the Camera is bound to
-  World* world;
-  
-  /* physical system - not needed yet */
-  float m; //!< mass
-  Vector *fs; //!< seil-kraft
-  Vector *a;  //!< acceleration
-  Vector *v;  //!< velocity
-  
-  /* elliptical camera mode variables */
-  float cameraOffset;
-  float cameraOffsetZ;
-  float deltaTime;
-  float t;
-  Vector r;
-  float rAbs;
-  float ka;
-  float a0;
-
-  Quaternion *from;
-  Quaternion *to;
-  Quaternion *res;
-  
-  
-  CAMERA_MODE cameraMode; //!< saves the camera mode: how the camera follows the entity
-  
-  void updateDesiredPlace ();
+  Vector toRelCoor;
+  float toFovy;
   
  public:
-  Camera (World* world);
-  virtual ~Camera ();
-  
-  void tick (Uint32 deltaT);
-  void apply ();
-  void bind (WorldEntity* entity);
+  Camera(void);
+  virtual ~Camera(void);
 
-  void setWorld(World* world);  
+  void lookAt(PNode* target);
+  PNode* getTarget();
 
+  void setAspectRatio(float aspectRatio);
+  void setFovy(float fovy);
+  void setClipRegion(float nearClip, float farClip);
+
+  void setViewMode(ViewMode mode);
+  void tick(float dt);
+  void apply (void);
 };
 
+//! A CameraTarget is where the Camera is looking at.
+class CameraTarget : public PNode 
+{
+  friend class Camera;             //! The CameraTarget is a friend of Camera. noone else needs a CameraTarget, so noone else can create it.
+  
+ private:
+  CameraTarget(void);
+  
+ public:
+  virtual ~CameraTarget(void);
+};
+
+
 #endif /* _CAMERA_H */
Index: orxonox/branches/levelloader/src/command_node.cc
===================================================================
--- orxonox/branches/levelloader/src/command_node.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/command_node.cc	(revision 3746)
@@ -22,4 +22,7 @@
 #include "game_loader.h"
 #include "world.h"
+#include "list.h"
+#include "orxonox.h"
+#include "debug.h"
 
 #include <stdio.h>
@@ -279,10 +282,12 @@
   if( this->world->command(cmd)) return;
 
-  WorldEntity* entity = bound->enumerate();
+  tIterator<WorldEntity>* iterator = bound->getIterator();
+  WorldEntity* entity = iterator->nextElement();
   while( entity != NULL)
     {
       entity->command (cmd); /*no absorbtion of command! strange*/
-      entity = bound->nextElement();
-    }
+      entity = iterator->nextElement();
+    }
+  delete iterator;
 }
 
Index: orxonox/branches/levelloader/src/command_node.h
===================================================================
--- orxonox/branches/levelloader/src/command_node.h	(revision 3606)
+++ orxonox/branches/levelloader/src/command_node.h	(revision 3746)
@@ -9,6 +9,8 @@
 #define _COMMAND_NODE_H
 
-#include "stdincl.h"
 
+#include "comincl.h"
+
+template<class T> class tList;
 class WorldEntity;
 class World;
Index: orxonox/branches/levelloader/src/defs/comincl.h
===================================================================
--- orxonox/branches/levelloader/src/defs/comincl.h	(revision 3746)
+++ orxonox/branches/levelloader/src/defs/comincl.h	(revision 3746)
@@ -0,0 +1,13 @@
+/*!
+  \file glincl.h
+  \brief This file includes gl Headers.
+  
+  no Class is defined here, but the opengl Headers
+*/
+
+#ifndef _COMINCL_H
+#define _COMINCL_H
+
+#include "message_structures.h"
+
+#endif /* _COMINCL_H */
Index: orxonox/branches/levelloader/src/defs/debug.h
===================================================================
--- orxonox/branches/levelloader/src/defs/debug.h	(revision 3606)
+++ orxonox/branches/levelloader/src/defs/debug.h	(revision 3746)
@@ -59,12 +59,15 @@
 #define DEBUG_MODULE_ORXONOX            0
 #define DEBUG_MODULE_WORLD              0
-#define DEBUG_MODULE_PNODE              2
+#define DEBUG_MODULE_PNODE              3
 #define DEBUG_MODULE_WORLD_ENTITY       0
 #define DEBUG_MODULE_COMMAND_NODE       0
+#define DEBUG_MODULE_GRAPHICS           0
+#define DEBUG_MODULE_LOAD               0
 
 #define DEBUG_MODULE_IMPORTER           0
 #define DEBUG_MODULE_TRACK_MANAGER      0
-#define DEBUG_MODULE_LIGHT              3
-#define DEBUG_MODULE_PLAYER             0
+#define DEBUG_MODULE_GARBAGE_COLLECTOR  0
+#define DEBUG_MODULE_LIGHT              0
+#define DEBUG_MODULE_PLAYER             3
 #define DEBUG_MODULE_MATH               0
 
Index: orxonox/branches/levelloader/src/defs/stdincl.h
===================================================================
--- orxonox/branches/levelloader/src/defs/stdincl.h	(revision 3606)
+++ orxonox/branches/levelloader/src/defs/stdincl.h	(revision 3746)
@@ -9,6 +9,4 @@
 #define _STDINCL_H
 		
-#define null 0   //!< null
-
 typedef unsigned char byte;
 
@@ -23,4 +21,5 @@
 
 #include <assert.h>
+#include <stddef.h>
 #include <stdlib.h>
 #include <string.h>
@@ -28,6 +27,4 @@
 #include "glincl.h"
 
-#include "error.h"
-#include "debug.h"
 
 // MATH //
@@ -39,8 +36,8 @@
 #include "list_template.h"
 #include "message_structures.h"
-#include "orxonox.h"
 #include "data_tank.h"
 #include "base_object.h"
 #include "factory.h"
+#include "debug.h"
 
 #define CREATE_FACTORY(x) \
Index: orxonox/branches/levelloader/src/game_loader.cc
===================================================================
--- orxonox/branches/levelloader/src/game_loader.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/game_loader.cc	(revision 3746)
@@ -25,4 +25,5 @@
 #include "vector.h"
 #include "factory.h"
+#include "debug.h"
 
 #include <string.h>
@@ -89,5 +90,10 @@
   switch(campaignID)
     {
-      // Debug Level 0: Debug level used to test the base frame work.
+      /* 
+	 Debug Level 0: Debug level used to test the base frame work.
+	 As you can see, all storyentity data is allocated before game
+	 start. the storyentity will load themselfs shortly before start
+	 through the StoryEntity::init() funtion.
+      */
     case DEBUG_CAMPAIGN_0:
       {
@@ -99,6 +105,10 @@
 
 	World* world1 = new World(DEBUG_WORLD_1);
-	world1->setNextStoryID(WORLD_ID_GAMEEND);
+	world1->setNextStoryID(WORLD_ID_2);
 	debugCampaign->addEntity(world1, WORLD_ID_1);
+
+	World* world2 = new World(DEBUG_WORLD_2);
+	world2->setNextStoryID(WORLD_ID_GAMEEND);
+	debugCampaign->addEntity(world2, WORLD_ID_2);
 
 	this->currentCampaign = debugCampaign;
Index: orxonox/branches/levelloader/src/game_loader.h
===================================================================
--- orxonox/branches/levelloader/src/game_loader.h	(revision 3606)
+++ orxonox/branches/levelloader/src/game_loader.h	(revision 3746)
@@ -1,8 +1,15 @@
+/*! 
+    \file game_loader.h
+    \brief loads campaigns, worlds and all other story_entities
+*/ 
+
 #ifndef _GAME_LOADER_H
 #define _GAME_LOADER_H
 
-#include "stdincl.h"
+//#include "stdincl.h"
 #include "story_def.h"
 #include "factory.h"
+#include "comincl.h"
+#include "error.h"
 
 //-----------------------------------------------------------------------------
@@ -14,5 +21,16 @@
 class CammandNode;
 
-
+//! The GameLoader
+/**
+   The game loader loads all game date. this is performed in the following way:
+   1. Read the structure of campaings and worlds
+   2. Create the instances of the tree: here _ALL_ StoryEntities are created
+      also if they are not yet used. the worlds should load their data in
+      the StoryEntity::load() and StoryEntity::init() functions! NOWHERE ELSE!
+      Elsewhere, all the data will be allocated at the beginning... mess...
+   3. StoryEntities are load() and init() before they start
+   4. once the gamloader starts the game there will be a campaing starting a
+      world. this is done by callaing those StoryEntity::start()
+*/
 class GameLoader 
 {
Index: orxonox/branches/levelloader/src/garbage_collector.cc
===================================================================
--- orxonox/branches/levelloader/src/garbage_collector.cc	(revision 3746)
+++ orxonox/branches/levelloader/src/garbage_collector.cc	(revision 3746)
@@ -0,0 +1,149 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_GARBAGE_COLLECTOR
+
+#include "garbage_collector.h"
+
+#include "world.h"
+#include "world_entity.h"
+#include "null_parent.h"
+
+#include "list.h"
+
+using namespace std;
+
+
+GarbageCollector* GarbageCollector::singletonRef = 0;
+
+/**
+   \brief standard constructor
+   \todo this constructor is not jet implemented - do it
+*/
+GarbageCollector::GarbageCollector () 
+{
+   this->setClassName ("GarbageCollection");
+   this->time = 0;
+   this->delay = 1.5f; /* clean up all 5.0 seconds */
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+GarbageCollector::~GarbageCollector () 
+{
+  // delete what has to be deleted here
+}
+
+
+/**
+   \brief this returns the singleton reference this this class
+   \returns singleton reference
+*/
+GarbageCollector* GarbageCollector::getInstance()
+{
+  if( singletonRef == NULL)
+    singletonRef = new GarbageCollector();
+  return singletonRef;
+}
+
+
+/**
+   \brief this sets the collection delay
+   \param delay
+   
+   after this delay, the garbage collector starts its work and begins to collect unused object
+   to delete them afterwards. only objects in the worldentity list from the world object are lookded
+   at. 
+*/
+void GarbageCollector::setCollectionDelay(float delay)
+{
+  this->delay = delay;
+}
+
+
+/**
+   \brief this foreces a garbage collection
+
+   if this function is called, the gc tries to initiate the garbage collection routines. actually
+   this should always work.
+*/
+void GarbageCollector::forceCollection()
+{
+  /* just make the time slitely bigger than the delay */
+  this->time = this->delay + 1;
+  /* and update, to get rid of the unused objects */
+  this->update();
+}
+
+
+/**
+   \brief this ticks the GarbageCollector to give it the time pulse
+   \param the time passed since last tick
+
+   like every other tick function eg. worldentity
+*/
+void GarbageCollector::tick(float time)
+{
+  this->time += time;
+}
+
+
+/**
+   \brief this updated the gargabe collection, if the time is ready
+
+
+*/
+void GarbageCollector::update()
+{
+  if( this->time < this->delay)
+    return;
+  /* garbage collect */
+  PRINTF(3)("=============================\n");
+  PRINTF(3)("Processing Garbage Collection\n");
+  PRINTF(3)("=============================\n");
+  int counter = 0;
+  WorldInterface* wi = WorldInterface::getInstance();
+  tList<WorldEntity>* list = wi->getEntityList();
+
+  tIterator<WorldEntity>* iterator = list->getIterator();
+  WorldEntity* entity = iterator->nextElement();
+  while( entity != NULL) 
+    { 
+      if( entity->isFinalized())
+	{
+	  PRINTF(4)("= finalizing object\n");
+	  ++counter;
+	  
+	  /* first remove out of entity list */
+	  list->remove(entity);
+	  /* second remove out of pnode tree */
+	  entity->remove();
+	  /* then finaly delete reference */
+	  delete entity;
+	}
+      entity = iterator->nextElement();
+    }
+
+  PRINTF(3)("= collected %i unused objects\n", counter);
+  PRINTF(3)("=============================\n");
+
+  /* reset time to count again up to this->delay */
+  this->time = 0;
+}
Index: orxonox/branches/levelloader/src/garbage_collector.h
===================================================================
--- orxonox/branches/levelloader/src/garbage_collector.h	(revision 3746)
+++ orxonox/branches/levelloader/src/garbage_collector.h	(revision 3746)
@@ -0,0 +1,42 @@
+/*! 
+    \file proto_class.h
+    \brief Definition of the proto class template, used quickly start work
+    \todo Example: this shows how to use simply add a Marker that here has to be done something.
+
+    The Protoclass exists, to help you quikly getting the run for how to develop in orxonox.
+    It is an example for the CODING-CONVENTION, and a starting-point for every class.
+*/
+
+#ifndef _GARBAGE_COLLECTOR_H
+#define _GARBAGE_COLLECTOR_H
+
+#include "base_object.h"
+
+
+//! this class maintains the garbage collection.
+/**
+   the class is been ticked by the world.cc and goes through the 
+   world_entity list to clean out all unused entities.
+*/
+class GarbageCollector : public BaseObject {
+
+ public:
+  GarbageCollector();
+  virtual ~GarbageCollector();
+  static GarbageCollector* getInstance();
+
+  void setCollectionDelay(float delay);
+
+  void forceCollection();
+
+  void tick(float time);
+  void update();
+
+ private:
+  static GarbageCollector* singletonRef;
+  float delay;                                        //!< this is the delay to wait until collection
+  float time;                                         //!< the current time
+
+};
+
+#endif /* _GARBAGE_COLLECTOR_H */
Index: orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.cc
===================================================================
--- orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.cc	(revision 3746)
@@ -41,4 +41,5 @@
 {
    this->setClassName ("GLMenuImageScreen");
+   this->init();
 }
 
@@ -50,6 +51,6 @@
 GLMenuImageScreen::~GLMenuImageScreen() 
 {
-  if (backMat)
-    delete backMat;
+  if (this->backMat)
+    delete this->backMat;
 }
 
@@ -81,5 +82,5 @@
   // Select Our VU Meter Background Texture
   this->backMat = new Material("load_screen");
-  this->backMat->setDiffuseMap("../data/pictures/load_screen.jpg");
+  this->backMat->setDiffuseMap("pictures/load_screen.jpg");
   this->maxValue = 10;
   this->currentValue = 0;
@@ -110,30 +111,9 @@
 void GLMenuImageScreen::draw ()
 {
-  /*
-  // Display a quad texture to the screen
-  glEnable(GL_TEXTURE_2D);
-  glBegin(GL_QUADS);
-  
-  // Display the top left vertice
-  glTexCoord2f(0.0f, 1.0f);
-  glVertex3f(-2.5, 2.5, 0);
-  
-  // Display the bottom left vertice
-  glTexCoord2f(0.0f, 0.0f);
-  glVertex3f(-2.5, -2.5, 0);
-  
-  // Display the bottom right vertice
-  glTexCoord2f(1.0f, 0.0f);
-  glVertex3f(2.5, -2.5, 0);
-  
-  // Display the top right vertice
-  glTexCoord2f(1.0f, 1.0f);
-  glVertex3f(2.5, 2.5, 0);
-
-  glEnd();
-  glEnable(GL_TEXTURE_2D);  
-  */
 
   glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
+
+  PRINTF(4)("GLMenuImagEscreen::draw() - drawing step %i/%i\n", 
+	 this->currentValue, this->maxValue);
 
   /* screen size */
@@ -154,6 +134,8 @@
   int barWidth = 230;
   int barHeight = 30;
-
-  int val = (int)((float)this->currentValue/(float)this->maxValue) * barWidth;
+  
+  float val = ((float)this->currentValue/(float)this->maxValue) * barWidth;
+  if( val > (float)barWidth)
+    val = (float)barWidth;
 
   glMatrixMode(GL_PROJECTION);
@@ -170,9 +152,10 @@
   glDisable(GL_LIGHTING);
 
+  /* draw the progress bar */
   glBegin(GL_QUADS);
   glColor3f(0.96, 0.84, 0.34);
   glVertex2i(barX, barY);
-  glVertex2i(barX + val, barY);
-  glVertex2i(barX + val, barY + barHeight);
+  glVertex2i(barX + (int)val, barY);
+  glVertex2i(barX + (int)val, barY + barHeight);
   glVertex2i(barX, barY + barHeight);
   glColor3f(1.0, 1.0, 1.0);
@@ -223,5 +206,5 @@
   glPopAttrib();
 
-  SDL_GL_SwapBuffers();                    
+  SDL_GL_SwapBuffers();              
 }
  
Index: orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.h
===================================================================
--- orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.h	(revision 3606)
+++ orxonox/branches/levelloader/src/glmenu/glmenu_imagescreen.h	(revision 3746)
@@ -45,4 +45,6 @@
   float offsetX, offsetY;    //!< offset of the image from left and up
   Material* backMat;         //!< Background Material.
+
+  /* progress bar values */
   int currentValue;          //!< the current count of step() calls fired yet
   int maxValue;              //!< total count of steps
Index: orxonox/branches/levelloader/src/lib/coord/helper_parent.h
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/helper_parent.h	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/coord/helper_parent.h	(revision 3746)
@@ -8,5 +8,5 @@
 #define _HELPER_PARENT_H
 
-#include "stdincl.h"
+
 #include "p_node.h"
 
Index: orxonox/branches/levelloader/src/lib/coord/null_parent.cc
===================================================================
--- orxonox/branches/levelloader/src/lib/coord/null_parent.cc	(revision 3606)
+++ orxonox/branches/levelloader/src/lib/coord/null_parent.cc	(revision 3746)
@@ -19,4 +19,7 @@
 
 #include "null_parent.h"
+#include "stdincl.h"
+#include "vector.h"
+#include "list.h"
 
 
@@ -51,5 +54,5 @@
   this->parent = this;
   this->mode = PNODE_ALL;
-  this->absCoordinate = *absCoordinate;
+  *this->absCoordinate = *absCoordinate;
   this->setName("NullParent");
 }
@@ -74,12 +77,14 @@
    worry, normaly...
 */
-void NullParent::update ()
+void NullParent::update (float dt)
 {
 
-  PRINTF(4)("NullParent::update - (%f, %f, %f)\n", this->absCoordinate.x, this->absCoordinate.y, this->absCoordinate.z);
-  this->absCoordinate = this->relCoordinate;
-  this->absDirection = parent->getAbsDir () * this->relDirection;
-  
-  PNode* pn = this->children->enumerate ();
+  PRINTF(4)("NullParent::update - (%f, %f, %f)\n", this->absCoordinate->x, this->absCoordinate->y, this->absCoordinate->z);
+  *this->absCoordinate = *this->relCoordinate;
+  *this->absDirection = parent->getAbsDir () * *this->relDirection;
+
+  tIterator<PNode>* iterator = this->children->getIterator();
+  //PNode* pn = this->children->enumerate ();
+  PNode* pn = iterator->nextElement();
   while( pn != NULL) 
     { 
@@ -89,6 +94,7 @@
       if( this->bRelDirChanged || this->bAbsDirChanged)
 	pn->parentDirChanged ();
-      pn->update ();
-      pn = this->children->nextElement ();
+      pn->update (dt);
+      //pn = this->children->nextElement ();
+      pn = iterator->nextElement();
     }
 
